package com.zhongshu.card.server.core.dao.projectAbout.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.client.model.org.projectDict.ProjectDictSearch;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.projectAbout.extend.ProjectDictDaoExtend;
import com.zhongshu.card.server.core.domain.org.ProjectDict;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class ProjectDictDaoImpl extends BaseImpl implements ProjectDictDaoExtend {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<ProjectDict> page(Pageable pageable, ProjectDictSearch param) {
        Criteria criteria = buildFilterCriteria(param);

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, ProjectDict.class);
    }

    private Criteria buildFilterCriteria(ProjectDictSearch param) {
        Criteria criteria = buildCriteriaNotOid(param);

        if (StringUtils.isNotEmpty(param.getProjectOid())) {
            criteria.and("projectOid").is(param.getProjectOid());
        }
        if (param.getState() != null) {
            criteria.and("state").is(param.getState());
        }

        if (param.getDictType() != null) {
            criteria.and("dictType").is(param.getDictType());
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();
        // 用户名称
        if (StringUtils.isNotEmpty(param.getName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getName() + ".*$");
            criterias.add(Criteria.where("name").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getCode())) {
            Pattern pattern = Pattern.compile("^.*" + param.getCode() + ".*$");
            criterias.add(Criteria.where("code").is(pattern));
        }
        if (!CollectionUtils.isEmpty(criterias)) {
            criteria.andOperator(criterias.toArray(new Criteria[]{}));
        }

        if (StringUtils.isNotEmpty(param.getKeyWord())) {
            Pattern pattern = Pattern.compile("^.*" + param.getKeyWord() + ".*$");
            criteria.orOperator(
                    Criteria.where("name").regex(pattern),
                    Criteria.where("code").regex(pattern)
            );
        }

        return criteria;
    }

}
